#include <avr/io.h>
#include <mmc_lib.h>
#include <fat.h>
#include <uart.h>
#include <stdlib.h>
#include <inttypes.h>

void fat_init()
{
	unsigned int VBR_START, root_dir_first_cluster;
	unsigned char string[10];
	
	
	
	mmc_set_blocklen(512);
	mmc_start_read_block(0, 9); // MBR auslesen
	mmc_read_buffer(&buffer[0],512);
	mmc_stop_read_block();
	
	VBR_START = buffer[454]; // VBR Adresse der ersten Partition holen
	
	mmc_start_read_block(VBR_START, 9); // VBR auslesen
	mmc_read_buffer(&buffer[0],512);
	mmc_stop_read_block();
	
	fat_begin_lba = VBR_START + (unsigned short)buffer[BPB_RsvdSecCnt]; //Number_of_Reserved_Sectors;
	cluster_begin_lba = VBR_START +  (unsigned short)buffer[BPB_RsvdSecCnt]  + (2 * *((unsigned long *)&buffer[BPB_SECperFat]));
	sectors_per_cluster = (unsigned char)buffer[BPB_SecPerClus];
	root_dir_first_cluster = *((unsigned long *)&buffer[BPB_RootClus]);
	
	
	/*Debugging...*/
	
	itoa(root_dir_first_cluster, &string[0], 10);
	uart_print("\nroot dir first cluster");
	uart_print(&string[0]);
	
	itoa(sectors_per_cluster, &string[0], 10);
	uart_print("\nsectors / cluster");
	uart_print(&string[0]);
	
	
	itoa(cluster_begin_lba, &string[0], 10);
	uart_print("\ncluster begin lba");
	uart_print(&string[0]);
	
	itoa(fat_begin_lba, &string[0], 10);
	uart_print("\nfat begin lba");
	uart_print(&string[0]);
	//uart_prints(&buffer[0]);
	
	itoa((unsigned int)buffer[BPB_SECperFat], &string[0], 10);
	uart_print("\nsecs / fat");
	uart_print(&string[0]);
	

}

uint32_t followClusterChain(unsigned long cluster)
{
	
	mmc_start_read_block(fat_begin_lba + (cluster / 128), 9); // Sektor auslesen in welchem der gewnschte Fat Eintrag steht.
	mmc_read_buffer(&buffer[0],512);
	mmc_stop_read_block();

	unsigned short nFatOffset  = ((cluster % 128) * 4) - 1; // 0...128 Offset des fat eintrages(4 byte lang) ausrechnen
		
	return (*((unsigned long *)&buffer[nFatOffset])); // An der Stelle nFatOffset den Fat eintrag auslesen und zurckgeben...

}

uint32_t getentry(unsigned short entry, unsigned char *buf)
{

	unsigned short i, EntryNmbr  = entry % 16 ; // DA EVTL NICHT -1
	unsigned short EntryOffset, table[16] = {0x00, 0x20, 0x40, 0x60, 0x80,0xA0,0xC0,0xE0,0x100,0x120,0x140,0x160,0x180,0x1A0,0x1C0,0x1E0};//Hat mit Rechnung nicht geklappt, desshalb mit Tabelle...
	unsigned char minibuf[4],string[10];
	uint32_t filesize;
	
		mmc_start_read_block(cluster_begin_lba +(entry / 16),9); // Sektor auslesen in welchem der gewnschte Fat Eintrag steht.
		mmc_read_buffer(&buffer[0],512);
		mmc_stop_read_block();
	
		EntryOffset = table[EntryNmbr]; // Offset berechnen
	

	for(i=EntryOffset;i<EntryOffset+11;i++){
			uart_putchar(buffer[i]);
			//*(buf++) = buffer[EntryOffset+i];
			
		}
		//*(buf++) = 0x00; //Eine NUll anhngen um zu zeigen dass der String hier fertig zu ende ist...
		
		
	if(buffer[EntryOffset+11] ==  0x0F || buffer[EntryOffset] == 0xE5 || buffer[EntryOffset] == 0x00) return 0;
		minibuf[0] = buffer[EntryOffset+26];
		minibuf[1] = buffer[EntryOffset+27];
		minibuf[2] = buffer[EntryOffset+20];
		minibuf[3] = buffer[EntryOffset+21];
		
		/*get filename*/
	
		clusterbegin = *((uint32_t *)&minibuf[0]);
		
	itoa(filesize, &string[0], 10); 
	uart_print(" size:"); 
	uart_print(&string[0]); //Zum Test auf Uart ausgeben (Hier stimmt der Wert noch)
	
	return clusterbegin;
}
/*unsigned long fopenE(unsigned long entry) // Liest eine Datei nach Entry #aus (nicht alphabetisch)
{	
	unsigned short a;
	unsigned long sector = cluster_begin_lba;
	unsigned char SecInClus = 0,b;
	unsigned long cluster = 0; // NUR FALLS IM ROOT DIR !!!!
	
	for(a=0;a<10000;a++){
		
		mmc_start_read_block(sector + SecInClus,9); // Sektor auslesen in welchem der gewnschte Fat Eintrag steht.
		mmc_read_buffer(&buffer[0],512);
		mmc_stop_read_block();
		
				
		while(b<16){
		
		
		
		b++;
		}
		SecInClus++;
		if(SecInClus == sectors_per_cluster) followClusterChain(cluster); cluster++;SecInClus=0;
	}
}*/



/*unsigned long filesizeE(unsigned long entry) // Gibt die Grsse einer Datei nach Entry #aus (nicht alphabetisch)
{
}

unsigned long opendir(unsigned char *buffer)
{
	while (*buffer)
	{		
		if(*buffer++ == '/');
	}
	return (0);
}*/